;;  -------------------------------------------------------------------
;;  NOM:        SO.ASM
;;  CREAT PER:  Sergio Blanco Cuaresma
;;		Francesc Galiano Baixauli
;;  DATA:       10/05/2001
;;  DESCRIPCIO: Funcio So: activa/desactiva l'altaveu del PC.
;;              void So (WORD DivFreq); **Corregida**
;;  -------------------------------------------------------------------

;       A continuaci s'acostuma a posar les DECLARACIONS "PUBLIQUES":
;       quines dades i funcions s'han de "veure" externament

PUBLIC _So

;       Segments de dades: _DATA (inicialitzades) i _BSS (no inicialitzades)

_DATA   SEGMENT WORD PUBLIC 'DATA'
_DATA   ENDS

_BSS    SEGMENT WORD PUBLIC 'BSS'
_BSS    ENDS

        ; els dos segments anteriors s'uneixen en un sol grup: DGROUP
DGROUP  GROUP   _DATA, _BSS

        ; declaraci d'on es suposa que apunten els registres de segment
ASSUME cs:Codi, ds:DGROUP


Codi SEGMENT BYTE PUBLIC 'CODE'

_So PROC FAR
        push    bp      ; BP es modificar
        mov     bp,sp   ; E. dinmic per accs a params. i vars. locals
        ;sub     sp, ... ; espai a la pila per variables locals
        push    ax     ; salvar registres que es modificaran
        
si:	cmp	word ptr [bp+6], 0	; Comparem Parametre DivFreq amb 0
        je	sino
        mov	ax, 0B6h	;Ordre: generar ona quadrada, amb divisor
        			; ATENCIO!!!
        			; La seguent instruccio es correte pq al ser ax de 16 bits
        			; agafa el port 43 i el 42. Hauriem de posar "out 43h, al"
        out	43h, ax		;	indicat a continuacio
        mov	ax, [bp+6]	; Parametre DivFreq
        out	42h, al		; LSB (Part baixa del divisor)
        mov	al, ah
        out	42h, al		; MSB (Part alta del divisor)
        in	al, 61h
        or	al, 00000011b
        out	61h, al		; Activem so
        jmp	fsi
sino:				; El parametre DivFreq = 0
        in	al, 61h
        and	al, 11111100b
        out	61h, al		; Aturem so
fsi:

        pop	ax     ; restaurar registres modificats per la rutina
        mov     sp,bp   ; recupera l'espai ocupat per variables locals
        pop     bp      ; recupera BP anterior
        ret             ; retorna. NO S'HAN DE TREURE ELS PARAMETRES !!!
_So ENDP

Codi ENDS

        END     ; final de fitxer
